<HTML>
<BODY BGCOLOR="white">
<PRE>
<FONT color="green">001</FONT>    /*<a name="line.1"></a>
<FONT color="green">002</FONT>     * =============================================================================<a name="line.2"></a>
<FONT color="green">003</FONT>     * Simplified BSD License, see http://www.opensource.org/licenses/<a name="line.3"></a>
<FONT color="green">004</FONT>     * -----------------------------------------------------------------------------<a name="line.4"></a>
<FONT color="green">005</FONT>     * Copyright (c) 2008-2009, Marco Terzer, Zurich, Switzerland<a name="line.5"></a>
<FONT color="green">006</FONT>     * All rights reserved.<a name="line.6"></a>
<FONT color="green">007</FONT>     * <a name="line.7"></a>
<FONT color="green">008</FONT>     * Redistribution and use in source and binary forms, with or without <a name="line.8"></a>
<FONT color="green">009</FONT>     * modification, are permitted provided that the following conditions are met:<a name="line.9"></a>
<FONT color="green">010</FONT>     * <a name="line.10"></a>
<FONT color="green">011</FONT>     *     * Redistributions of source code must retain the above copyright notice, <a name="line.11"></a>
<FONT color="green">012</FONT>     *       this list of conditions and the following disclaimer.<a name="line.12"></a>
<FONT color="green">013</FONT>     *     * Redistributions in binary form must reproduce the above copyright <a name="line.13"></a>
<FONT color="green">014</FONT>     *       notice, this list of conditions and the following disclaimer in the <a name="line.14"></a>
<FONT color="green">015</FONT>     *       documentation and/or other materials provided with the distribution.<a name="line.15"></a>
<FONT color="green">016</FONT>     *     * Neither the name of the Swiss Federal Institute of Technology Zurich <a name="line.16"></a>
<FONT color="green">017</FONT>     *       nor the names of its contributors may be used to endorse or promote <a name="line.17"></a>
<FONT color="green">018</FONT>     *       products derived from this software without specific prior written <a name="line.18"></a>
<FONT color="green">019</FONT>     *       permission.<a name="line.19"></a>
<FONT color="green">020</FONT>     * <a name="line.20"></a>
<FONT color="green">021</FONT>     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" <a name="line.21"></a>
<FONT color="green">022</FONT>     * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE <a name="line.22"></a>
<FONT color="green">023</FONT>     * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE <a name="line.23"></a>
<FONT color="green">024</FONT>     * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE <a name="line.24"></a>
<FONT color="green">025</FONT>     * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR <a name="line.25"></a>
<FONT color="green">026</FONT>     * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF <a name="line.26"></a>
<FONT color="green">027</FONT>     * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS <a name="line.27"></a>
<FONT color="green">028</FONT>     * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN <a name="line.28"></a>
<FONT color="green">029</FONT>     * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) <a name="line.29"></a>
<FONT color="green">030</FONT>     * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE <a name="line.30"></a>
<FONT color="green">031</FONT>     * POSSIBILITY OF SUCH DAMAGE.<a name="line.31"></a>
<FONT color="green">032</FONT>     * =============================================================================<a name="line.32"></a>
<FONT color="green">033</FONT>     */<a name="line.33"></a>
<FONT color="green">034</FONT>    package ch.javasoft.xml.config;<a name="line.34"></a>
<FONT color="green">035</FONT>    <a name="line.35"></a>
<FONT color="green">036</FONT>    import java.io.OutputStream;<a name="line.36"></a>
<FONT color="green">037</FONT>    import java.io.OutputStreamWriter;<a name="line.37"></a>
<FONT color="green">038</FONT>    import java.io.PrintWriter;<a name="line.38"></a>
<FONT color="green">039</FONT>    import java.io.StringWriter;<a name="line.39"></a>
<FONT color="green">040</FONT>    import java.io.Writer;<a name="line.40"></a>
<FONT color="green">041</FONT>    import java.util.Iterator;<a name="line.41"></a>
<FONT color="green">042</FONT>    <a name="line.42"></a>
<FONT color="green">043</FONT>    import org.dom4j.Attribute;<a name="line.43"></a>
<FONT color="green">044</FONT>    import org.dom4j.CharacterData;<a name="line.44"></a>
<FONT color="green">045</FONT>    import org.dom4j.Comment;<a name="line.45"></a>
<FONT color="green">046</FONT>    import org.dom4j.Document;<a name="line.46"></a>
<FONT color="green">047</FONT>    import org.dom4j.Element;<a name="line.47"></a>
<FONT color="green">048</FONT>    import org.dom4j.Node;<a name="line.48"></a>
<FONT color="green">049</FONT>    <a name="line.49"></a>
<FONT color="green">050</FONT>    /**<a name="line.50"></a>
<FONT color="green">051</FONT>     * The &lt;tt&gt;XmlPrint&lt;/tt&gt; class contains methods to print xml nicely, that is<a name="line.51"></a>
<FONT color="green">052</FONT>     * whith desired indenting.<a name="line.52"></a>
<FONT color="green">053</FONT>     * &lt;p&gt;<a name="line.53"></a>
<FONT color="green">054</FONT>     * The current implementation does not support textual content and does not <a name="line.54"></a>
<FONT color="green">055</FONT>     * print comments. A supported xml file should thus contain textual information<a name="line.55"></a>
<FONT color="green">056</FONT>     * in the attributes of the elements, and elements themselves should only <a name="line.56"></a>
<FONT color="green">057</FONT>     * contain attributes and nested elements.   <a name="line.57"></a>
<FONT color="green">058</FONT>     */<a name="line.58"></a>
<FONT color="green">059</FONT>    public class XmlPrint {<a name="line.59"></a>
<FONT color="green">060</FONT>            <a name="line.60"></a>
<FONT color="green">061</FONT>            protected final String mIndention;<a name="line.61"></a>
<FONT color="green">062</FONT>            <a name="line.62"></a>
<FONT color="green">063</FONT>            /**<a name="line.63"></a>
<FONT color="green">064</FONT>             * Constructor for default indention, that is a single tab per indention<a name="line.64"></a>
<FONT color="green">065</FONT>             * level<a name="line.65"></a>
<FONT color="green">066</FONT>             */<a name="line.66"></a>
<FONT color="green">067</FONT>            public XmlPrint() {<a name="line.67"></a>
<FONT color="green">068</FONT>                    this("\t");<a name="line.68"></a>
<FONT color="green">069</FONT>            }<a name="line.69"></a>
<FONT color="green">070</FONT>            /**<a name="line.70"></a>
<FONT color="green">071</FONT>             * Constructor for given indention<a name="line.71"></a>
<FONT color="green">072</FONT>             * @param indention the desired indention per level<a name="line.72"></a>
<FONT color="green">073</FONT>             */<a name="line.73"></a>
<FONT color="green">074</FONT>            public XmlPrint(String indention) {<a name="line.74"></a>
<FONT color="green">075</FONT>                    mIndention = indention;<a name="line.75"></a>
<FONT color="green">076</FONT>            }<a name="line.76"></a>
<FONT color="green">077</FONT>    <a name="line.77"></a>
<FONT color="green">078</FONT>            /**<a name="line.78"></a>
<FONT color="green">079</FONT>             * Print the given document to the standard output<a name="line.79"></a>
<FONT color="green">080</FONT>             * @param doc the xml document<a name="line.80"></a>
<FONT color="green">081</FONT>             */<a name="line.81"></a>
<FONT color="green">082</FONT>            public void print(Document doc) {<a name="line.82"></a>
<FONT color="green">083</FONT>                    print(doc, System.out);<a name="line.83"></a>
<FONT color="green">084</FONT>            }<a name="line.84"></a>
<FONT color="green">085</FONT>            /**<a name="line.85"></a>
<FONT color="green">086</FONT>             * Print the given document to the given output stream<a name="line.86"></a>
<FONT color="green">087</FONT>             * @param doc           the xml document<a name="line.87"></a>
<FONT color="green">088</FONT>             * @param out           the output stream to write to<a name="line.88"></a>
<FONT color="green">089</FONT>             */<a name="line.89"></a>
<FONT color="green">090</FONT>            public void print(Document doc, OutputStream out) {<a name="line.90"></a>
<FONT color="green">091</FONT>                    print(doc, new OutputStreamWriter(out));<a name="line.91"></a>
<FONT color="green">092</FONT>            }<a name="line.92"></a>
<FONT color="green">093</FONT>            /**<a name="line.93"></a>
<FONT color="green">094</FONT>             * Print the given document using the given writer<a name="line.94"></a>
<FONT color="green">095</FONT>             * @param doc           the xml document<a name="line.95"></a>
<FONT color="green">096</FONT>             * @param writer        the writer to use for the output<a name="line.96"></a>
<FONT color="green">097</FONT>             */<a name="line.97"></a>
<FONT color="green">098</FONT>            public void print(Document doc, Writer writer) {<a name="line.98"></a>
<FONT color="green">099</FONT>                    print(doc, writer instanceof PrintWriter ? (PrintWriter)writer : new PrintWriter(writer));<a name="line.99"></a>
<FONT color="green">100</FONT>            }       <a name="line.100"></a>
<FONT color="green">101</FONT>            /**<a name="line.101"></a>
<FONT color="green">102</FONT>             * Print the given document using the given print writer<a name="line.102"></a>
<FONT color="green">103</FONT>             * @param doc           the xml document<a name="line.103"></a>
<FONT color="green">104</FONT>             * @param writer        the print writer to use for the output<a name="line.104"></a>
<FONT color="green">105</FONT>             */<a name="line.105"></a>
<FONT color="green">106</FONT>            public void print(Document doc, PrintWriter writer) {<a name="line.106"></a>
<FONT color="green">107</FONT>            printDeclaration(doc, writer);<a name="line.107"></a>
<FONT color="green">108</FONT>            print(doc.getRootElement(), writer);<a name="line.108"></a>
<FONT color="green">109</FONT>            }       <a name="line.109"></a>
<FONT color="green">110</FONT>            <a name="line.110"></a>
<FONT color="green">111</FONT>            /**<a name="line.111"></a>
<FONT color="green">112</FONT>             * Print the given element to the standard output<a name="line.112"></a>
<FONT color="green">113</FONT>             * @param elem the xml element<a name="line.113"></a>
<FONT color="green">114</FONT>             */<a name="line.114"></a>
<FONT color="green">115</FONT>            public void print(Element elem) {<a name="line.115"></a>
<FONT color="green">116</FONT>                    print(elem, System.out);<a name="line.116"></a>
<FONT color="green">117</FONT>            }<a name="line.117"></a>
<FONT color="green">118</FONT>            /**<a name="line.118"></a>
<FONT color="green">119</FONT>             * Print the given element to the given output stream<a name="line.119"></a>
<FONT color="green">120</FONT>             * @param elem          the xml element<a name="line.120"></a>
<FONT color="green">121</FONT>             * @param out           the output stream to write to<a name="line.121"></a>
<FONT color="green">122</FONT>             */<a name="line.122"></a>
<FONT color="green">123</FONT>            public void print(Element elem, OutputStream out) {<a name="line.123"></a>
<FONT color="green">124</FONT>                    print(elem, new OutputStreamWriter(out));<a name="line.124"></a>
<FONT color="green">125</FONT>            }<a name="line.125"></a>
<FONT color="green">126</FONT>            /**<a name="line.126"></a>
<FONT color="green">127</FONT>             * Print the given element using the given writer<a name="line.127"></a>
<FONT color="green">128</FONT>             * @param elem the xml element<a name="line.128"></a>
<FONT color="green">129</FONT>             * @param writer        the writer to use for the output<a name="line.129"></a>
<FONT color="green">130</FONT>             */<a name="line.130"></a>
<FONT color="green">131</FONT>            public void print(Element elem, Writer writer) {<a name="line.131"></a>
<FONT color="green">132</FONT>                    print(elem, writer instanceof PrintWriter ? (PrintWriter)writer : new PrintWriter(writer));<a name="line.132"></a>
<FONT color="green">133</FONT>            }<a name="line.133"></a>
<FONT color="green">134</FONT>            /**<a name="line.134"></a>
<FONT color="green">135</FONT>             * Print the given element using the given print writer<a name="line.135"></a>
<FONT color="green">136</FONT>             * @param elem the xml element<a name="line.136"></a>
<FONT color="green">137</FONT>             * @param writer        the print writer to use for the output<a name="line.137"></a>
<FONT color="green">138</FONT>             */<a name="line.138"></a>
<FONT color="green">139</FONT>            public void print(Element elem, PrintWriter writer) {<a name="line.139"></a>
<FONT color="green">140</FONT>                    print(elem, "", writer);<a name="line.140"></a>
<FONT color="green">141</FONT>            }<a name="line.141"></a>
<FONT color="green">142</FONT>            /**<a name="line.142"></a>
<FONT color="green">143</FONT>             * Print the given element using the given print writer and initial <a name="line.143"></a>
<FONT color="green">144</FONT>             * indention<a name="line.144"></a>
<FONT color="green">145</FONT>             * @param elem          the xml element<a name="line.145"></a>
<FONT color="green">146</FONT>             * @param indention     the initial indention<a name="line.146"></a>
<FONT color="green">147</FONT>             * @param writer        the print writer to use for the output<a name="line.147"></a>
<FONT color="green">148</FONT>             */<a name="line.148"></a>
<FONT color="green">149</FONT>            @SuppressWarnings("unchecked")<a name="line.149"></a>
<FONT color="green">150</FONT>            public void print(Element elem, String indention, PrintWriter writer) {<a name="line.150"></a>
<FONT color="green">151</FONT>                    writer.print(indention + "&lt;" + elem.getName());<a name="line.151"></a>
<FONT color="green">152</FONT>                    <a name="line.152"></a>
<FONT color="green">153</FONT>                    Iterator&lt;Attribute&gt; itAtt = elem.attributeIterator();<a name="line.153"></a>
<FONT color="green">154</FONT>                    Iterator&lt;Element&gt; itElem  = elem.elementIterator();<a name="line.154"></a>
<FONT color="green">155</FONT>    <a name="line.155"></a>
<FONT color="green">156</FONT>                    if (elem.hasMixedContent() || (elem.hasContent() &amp;&amp; !itElem.hasNext())) {<a name="line.156"></a>
<FONT color="green">157</FONT>                            Iterator&lt;Node&gt; it = elem.nodeIterator();<a name="line.157"></a>
<FONT color="green">158</FONT>                            while (it.hasNext()) {<a name="line.158"></a>
<FONT color="green">159</FONT>                                    Node node = it.next();<a name="line.159"></a>
<FONT color="green">160</FONT>                                    if (node instanceof CharacterData) {                                    <a name="line.160"></a>
<FONT color="green">161</FONT>                                            if (!(node instanceof Comment) &amp;&amp; node.getText().trim().length() != 0) {<a name="line.161"></a>
<FONT color="green">162</FONT>                                                    throw new IllegalArgumentException("text content not supported: \"" + node.getText() + "\"");                                           <a name="line.162"></a>
<FONT color="green">163</FONT>                                            }<a name="line.163"></a>
<FONT color="green">164</FONT>                                    }<a name="line.164"></a>
<FONT color="green">165</FONT>                                    else if (!(node instanceof Element || node instanceof Attribute)) {<a name="line.165"></a>
<FONT color="green">166</FONT>                                            throw new IllegalArgumentException("only attributes and elements are supported");                                       <a name="line.166"></a>
<FONT color="green">167</FONT>                                    }<a name="line.167"></a>
<FONT color="green">168</FONT>                            }<a name="line.168"></a>
<FONT color="green">169</FONT>                    }<a name="line.169"></a>
<FONT color="green">170</FONT>                    while (itAtt.hasNext()) {<a name="line.170"></a>
<FONT color="green">171</FONT>                            Attribute att = itAtt.next();<a name="line.171"></a>
<FONT color="green">172</FONT>                            final String attName    = att.getName();<a name="line.172"></a>
<FONT color="green">173</FONT>                            final String attValue   = att.getValue();<a name="line.173"></a>
<FONT color="green">174</FONT>                            writer.print(" " + attName + "=\"" + escapeAttributeValue(attValue) + "\"");<a name="line.174"></a>
<FONT color="green">175</FONT>                    }<a name="line.175"></a>
<FONT color="green">176</FONT>                    if (!itElem.hasNext()) {<a name="line.176"></a>
<FONT color="green">177</FONT>                            writer.println("/&gt;");<a name="line.177"></a>
<FONT color="green">178</FONT>                    }<a name="line.178"></a>
<FONT color="green">179</FONT>                    else {<a name="line.179"></a>
<FONT color="green">180</FONT>                            writer.println("&gt;");<a name="line.180"></a>
<FONT color="green">181</FONT>                            while (itElem.hasNext()) {<a name="line.181"></a>
<FONT color="green">182</FONT>                                    print(itElem.next(), indention + getIndention(), writer);<a name="line.182"></a>
<FONT color="green">183</FONT>                            }<a name="line.183"></a>
<FONT color="green">184</FONT>                            writer.println(indention + "&lt;/" + elem.getName() + "&gt;");                  <a name="line.184"></a>
<FONT color="green">185</FONT>                    }<a name="line.185"></a>
<FONT color="green">186</FONT>                    writer.flush();<a name="line.186"></a>
<FONT color="green">187</FONT>            }<a name="line.187"></a>
<FONT color="green">188</FONT>            <a name="line.188"></a>
<FONT color="green">189</FONT>            /**<a name="line.189"></a>
<FONT color="green">190</FONT>             * Replaces quotes and less than by the xml escaped symbol<a name="line.190"></a>
<FONT color="green">191</FONT>             * <a name="line.191"></a>
<FONT color="green">192</FONT>             * @param value the unescaped value<a name="line.192"></a>
<FONT color="green">193</FONT>             * @return the escaped value<a name="line.193"></a>
<FONT color="green">194</FONT>             */<a name="line.194"></a>
<FONT color="green">195</FONT>            private static String escapeAttributeValue(String value) {<a name="line.195"></a>
<FONT color="green">196</FONT>                    return value.replaceAll("\"", "&amp;quot;").replaceAll("&lt;", "&amp;lt;");<a name="line.196"></a>
<FONT color="green">197</FONT>            }<a name="line.197"></a>
<FONT color="green">198</FONT>            <a name="line.198"></a>
<FONT color="green">199</FONT>            /**<a name="line.199"></a>
<FONT color="green">200</FONT>             * Returns the given document as a string<a name="line.200"></a>
<FONT color="green">201</FONT>             * @param doc the xml document<a name="line.201"></a>
<FONT color="green">202</FONT>             */<a name="line.202"></a>
<FONT color="green">203</FONT>            public String toString(Document doc) {<a name="line.203"></a>
<FONT color="green">204</FONT>                    StringWriter sw = new StringWriter();<a name="line.204"></a>
<FONT color="green">205</FONT>                    print(doc, sw);<a name="line.205"></a>
<FONT color="green">206</FONT>                    return sw.toString();<a name="line.206"></a>
<FONT color="green">207</FONT>            }<a name="line.207"></a>
<FONT color="green">208</FONT>            /**<a name="line.208"></a>
<FONT color="green">209</FONT>             * Returns the given element as a string<a name="line.209"></a>
<FONT color="green">210</FONT>             * @param elem the xml element<a name="line.210"></a>
<FONT color="green">211</FONT>             */<a name="line.211"></a>
<FONT color="green">212</FONT>            public String toString(Element elem) {<a name="line.212"></a>
<FONT color="green">213</FONT>                    StringWriter sw = new StringWriter();<a name="line.213"></a>
<FONT color="green">214</FONT>                    print(elem, sw);<a name="line.214"></a>
<FONT color="green">215</FONT>                    return sw.toString();<a name="line.215"></a>
<FONT color="green">216</FONT>            }<a name="line.216"></a>
<FONT color="green">217</FONT>            <a name="line.217"></a>
<FONT color="green">218</FONT>            <a name="line.218"></a>
<FONT color="green">219</FONT>            /**<a name="line.219"></a>
<FONT color="green">220</FONT>             * Prints the xml declaration (the first line of an xml file)<a name="line.220"></a>
<FONT color="green">221</FONT>             * @param doc           the xml document<a name="line.221"></a>
<FONT color="green">222</FONT>             * @param writer        the writer to use for the output<a name="line.222"></a>
<FONT color="green">223</FONT>             */<a name="line.223"></a>
<FONT color="green">224</FONT>            protected void printDeclaration(Document doc, PrintWriter writer) {<a name="line.224"></a>
<FONT color="green">225</FONT>            String encoding = doc.getXMLEncoding();<a name="line.225"></a>
<FONT color="green">226</FONT>    <a name="line.226"></a>
<FONT color="green">227</FONT>            // Assume 1.0 version<a name="line.227"></a>
<FONT color="green">228</FONT>            writer.write("&lt;?xml version=\"1.0\"");<a name="line.228"></a>
<FONT color="green">229</FONT>            if (encoding == null || encoding.equals("UTF8")) {<a name="line.229"></a>
<FONT color="green">230</FONT>                writer.write(" encoding=\"UTF-8\"");<a name="line.230"></a>
<FONT color="green">231</FONT>            } <a name="line.231"></a>
<FONT color="green">232</FONT>            else {<a name="line.232"></a>
<FONT color="green">233</FONT>                writer.write(" encoding=\"" + encoding + "\"");<a name="line.233"></a>
<FONT color="green">234</FONT>            }<a name="line.234"></a>
<FONT color="green">235</FONT>            writer.write("?&gt;");<a name="line.235"></a>
<FONT color="green">236</FONT>            writer.println();<a name="line.236"></a>
<FONT color="green">237</FONT>            }<a name="line.237"></a>
<FONT color="green">238</FONT>            <a name="line.238"></a>
<FONT color="green">239</FONT>            /**<a name="line.239"></a>
<FONT color="green">240</FONT>             * Returns the per-level indention. Has been specified when this <a name="line.240"></a>
<FONT color="green">241</FONT>             * &lt;code&gt;XmlPrint&lt;/code&gt; instance was instantiated.<a name="line.241"></a>
<FONT color="green">242</FONT>             */<a name="line.242"></a>
<FONT color="green">243</FONT>            protected String getIndention() {<a name="line.243"></a>
<FONT color="green">244</FONT>                    return mIndention;<a name="line.244"></a>
<FONT color="green">245</FONT>            }<a name="line.245"></a>
<FONT color="green">246</FONT>            <a name="line.246"></a>
<FONT color="green">247</FONT>    }<a name="line.247"></a>




























































</PRE>
</BODY>
</HTML>
